
 /*************************************************************************
 *
 * *ADC mereni tlaku z MPX
 * 
 *************************************************************************/         

#include <stdio.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "ADC_pres.h"


/******************************************************************
 * LOW LEVEL funkce pro 1-wire sbernici
 ******************************************************************/ 



void ADCInit(void)	//inicializace ad
{
 ADMUX = 0b00000000;
 ADCSRA |= _BV(ADEN) | _BV(ADPS1) | _BV(ADPS2) ; 
}

void ADC_start(void)	//zacatek mereni
{
  ADCSRA |= _BV(ADSC); // zahajime mereni
	while  (!(ADCSRA & _BV(ADIF))); // cekame na dokonceni
	ADCSRA |= _BV(ADIF);
}

unsigned char zmer_tlak(int *result)
{

    int L_vystup, napeti, tlak_abs;
    
    L_vystup = ADCL + 256*(ADCH&3); // 10 bits ADC input      
    napeti=((L_vystup*5)/1.024);
    tlak_abs = ((((napeti)/5) +95)/0.9)+27;
    *result = tlak_abs;
}

