/*
 * meteo_rx.c
 *
 * pijmaci modul meteostanice
 *
 * Ji Dvok, 5.2010 
 */  

#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include "lcd_h.h"
#include "1wire.h"
#include "ADC_pres.h"
#include "RFM12B.h"

/**************MACROS*********************************************/

#define LED_G_OFF() PORTC &= ~(1<<4)
#define LED_G_ON() PORTC |= (1<<4)
#define LED_Y_OFF() PORTC &= ~(1<<3)
#define LED_Y_ON() PORTC |= (1<<3)
#define LED_R_OFF() PORTC &= ~(1<<2)
#define LED_R_ON() PORTC |= (1<<2)

#define F_OSC 4000000
#define UART_BAUD_RATE 9600
#define UART_BAUD_CALC(UART_BAUD_RATE,F_OSC) ((F_OSC)/((UART_BAUD_RATE)*16l)-1)

/**************FUNCTIONS*********************************************/

void USARTInit(void) {
	UBRRH = (unsigned char)(UART_BAUD_CALC(UART_BAUD_RATE,F_OSC)>>8);
	UBRRL = (unsigned char)UART_BAUD_CALC(UART_BAUD_RATE,F_OSC);
	UCSRB = (1 << TXEN);
	UCSRC = (1 << URSEL) | (1 << UCSZ0) | (1 << UCSZ1);
}

void usart_putc(unsigned char c) {
  while(!(UCSRA & (1 << UDRE)));
	UDR = c;
}

void usart_puts (char *s) {
	while (*s) {
		usart_putc(*s);
		s++;
	}
}



unsigned char zobraz_teplotu(int z)	
{
   char u[3];
   char v[3];
   int c=0;
   int d=0;

   c=z/100;
   d=z%100;
        
   utoa(c, u, 10);  	// prevod do dekadicke s
   utoa(d, v, 10);      // prevod do dekadicke s
	    
   lcd_gotoxy(0,0);
   lcd_puts("Ti:");
   lcd_puts(u);
   lcd_puts(".");
   lcd_puts(v);
   lcd_gotoxy(9,0);

}

/**************MAIN*********************************************/
int main(void) {
char temp [5];
char humi [5];
char dew [5];
int tlak_abs;
int temperature;
char connect [] = "ATDT88.86.103.249,80\r";
char buffer [140];
char buffer2 [5];
int j=0;

OWInit();
USARTInit();
portInit();
ADCInit();
RFInit();
lcdInit();

FIFOReset();
LED_G_ON();
lcd_puts("Waiting...");

while(1) {
  temp[0] = rfRecv();
  temp[1] = rfRecv();
  temp[2] = rfRecv();
  temp[3] = rfRecv();
  temp[4] = rfRecv();
  humi[0] = rfRecv();
  humi[1] = rfRecv();
  humi[2] = rfRecv();
  humi[3] = rfRecv();
  humi[4] = rfRecv();
  dew[0] = rfRecv();
  dew[1] = rfRecv();
  dew[2] = rfRecv();
  dew[3] = rfRecv();
  dew[4] = rfRecv();
  LED_Y_ON();

  OWConvertAll();
  OWReadTemperature(&temperature); //nate teplotu a updatuje promennou 
  zobraz_teplotu(temperature);

  ADC_start();
  zmer_tlak(&tlak_abs);

  sprintf(buffer2,"%d",tlak_abs);

 lcd_gotoxy(7,0);
 lcd_puts(" To:");
 lcd_puts(temp);
 lcd_gotoxy(0,1);
 lcd_puts("P:");
 lcd_puts(buffer2);
 lcd_gotoxy(6,1);
 lcd_puts("  H:");
 lcd_puts(humi);
 LED_Y_OFF();
 j++;

if (j==44){
  sprintf(buffer,"GET /meteo/meteo.php?proceed=write&t1=%d&t2=%s&h=%s&p=%d&d=%s HTTP/1.1\r\nHost: www.jiridvorak.ic.cz\r\n\r\n",temperature,temp,humi,tlak_abs,dew);
  usart_puts(connect);
  _delay_ms(100);
  usart_puts(buffer);
  j=0;
  }

  
  
  
  FIFOReset();
  }
}