/***********************************************************************************
Project:          RFM12B quick_start 
Filename:         RFM12B.c    

Prozessor:        ATmega8
Compiler:         

Autor:            
Copyrigth:        

Uprava pro meteostanici: Jiri Dvorak 
Datum: 1.3.2010   
*/



//------------------------------------------------------------------------------
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "RFM12B.h"


//----------------------------------------------------------------------------------



void portInit() {
  HI(CS);
  HI(SDI);
  LO(SCK);
  DDRB = (1<<CS) | (1<<SDI) | (1<<SCK) | (1<<0);
  DDRC = (1<<2) | (1<<3) | (1<<4);
}


unsigned int writeCmd(unsigned int cmd) {
  unsigned char i;
  unsigned int recv;
  recv = 0;
  LO(SCK);
  LO(CS);
  for(i=0; i<16; i++) {
    if(cmd&0x8000) HI(SDI); else LO(SDI);
    HI(SCK);
    recv<<=1;
    if( PINB&(1<<SDO) ) {
      recv|=0x0001;
    }
    LO(SCK);
    cmd<<=1;
  }
  HI(CS);
  return recv;
}

void RFInit() {
  writeCmd(0x80E7); //EL,EF,868band,12.0pF
  writeCmd(0x8299); //er,!ebb,ET,ES,EX,!eb,!ew,DC
  writeCmd(0xA640); //freq select
  writeCmd(0xC647); //x kbps
  writeCmd(0x94A0); //VDI,FAST,134kHz,0dBm,-103dBm
  writeCmd(0xC2AC); //AL,!ml,DIG,DQD4
  writeCmd(0xCA81); //FIFO8,SYNC,!ff,DR
  writeCmd(0xCED4); //SYNC=2DD4;
  writeCmd(0xC483); //@PWR,NO RSTRIC,!st,!fi,OE,EN
  writeCmd(0x9850); //!mp,90kHz,MAX OUT
  writeCmd(0xCC17); //!OB1,!OB0, LPX,!ddy,DDIT,BW0
  writeCmd(0xE000); //NOT USE
  writeCmd(0xC800); //NOT USE
  writeCmd(0xC040); //1.66MHz,2.2V
}

void rfSend(unsigned char data){
  
  while(WAIT_NIRQ_LOW());
  
  writeCmd(0xB800 + data);
}

void FIFOReset(void) 
{
  writeCmd(0xCA81);
  writeCmd(0xCA83);
}

unsigned char rfRecv() {
unsigned int data;
while(1) {
data = writeCmd(0x0000);
if ( (data&0x8000) ) {

data = writeCmd(0xB000);
return (data&0x00FF);
}
}
}


